<cfinclude template="opensource.cfm">
<cfzip action="list" file="#application.paths.sDrive#\IntranetConnections.ras" name="qryManifest" recurse="yes" />

<cffunction name="deleteCFEncoded" access="private" output="true"
	hint="Helper function to delete all non-opensource cfencoded CFML files from a folder">
	<cfargument name="folder" type="string" required="true">
	<cfargument name="lstOpenSource" type="string" required="true">
	<cfargument name="qryManifest" type="any" required="true">
	<cfargument name="startFolder" type="string" required="false" default="#arguments.folder#">
	
	<cfset var dirList = "">
	<cfset var exts = "*.cfm,*.cfml,*.cfc,*.cfr">
	<cfset var ext = "">
	<cfset var sName = "">
	<cfset var qryManifestCheck = "">
	<!--- the list of open source files now contains "\Intranet" in the path, remove that from the path for deleteCFML compatibility  --->
	<cfset arguments.lstOpenSource = ReplaceNoCase(arguments.lstOpenSource,"\Intranet","","all")>
	<!--- ignore product updates folder --->
	<cfif arguments.folder NEQ "#arguments.startFolder#\_CleanFiles">
	
		<!--- delete all cfm, cfml, cfr, and cfc files in the folder (not open source and in manifest) --->
		<cfloop list="#exts#" index="ext">
			<cfdirectory action="list" type="file" filter="#ext#" directory="#arguments.folder#" name="dirList">
			<cfloop query="dirList">
				
				<!--- check if file is cfencoded --->
				<cfset theFile = FileOpen("#arguments.folder#\#dirList.name#")>
				<cfset firstLine = "">
				<cftry><cfset firstLine = FileReadLine(theFile)><cfcatch type="any"></cfcatch></cftry>
				<cfset FileClose(theFile)>
				
				
				<!--- convert file name to compiled class name --->
				<cfset sName = dirList.name>
				<cfif IsNumeric(Left(sName, 1))>
					<cfset sName = "_" & sName>
				</cfif>
				<cfset sName = LCase("#ReplaceNoCase(ReplaceNoCase(arguments.folder, arguments.startFolder, ''), '\', '/', 'all')#/#sName#")>
				<cfset sName = ReplaceNoCase(sName, ".cfm", "_cfm$cf.class")>
				<cfset sName = ReplaceNoCase(sName, ".cfml", "_cfml$cf.class")>
				<cfset sName = ReplaceNoCase(sName, ".cfr", "_cfr$cf.class")>
				<cfset sName = ReplaceNoCase(sName, ".cfc", "_cfc$cf.class")>
				<cfset sName = Right(sName, Len(sName) - 1)>
					
				<!--- check if file is in manifest --->				
				<cfquery name="qryManifestCheck" dbtype="query">
					SELECT		*
					FROM		qryManifest
					WHERE		name = '#sName#'
				</cfquery>
				
				<!--- delete file --->
				<cfif firstLine EQ "Allaire Cold Fusion Template" OR (NOT ListFindNoCase(arguments.lstOpenSource, "#ReplaceNoCase(arguments.folder, arguments.startFolder, '')#\#dirList.name#")
					AND qryManifestCheck.RecordCount
					AND NOT FindNoCase("cfregdn.cfm", dirList.name))>
					Deleted: <cfoutput>#arguments.folder#\#dirList.name#</cfoutput><br/>
					<cffile action="delete" file="#arguments.folder#\#dirList.name#">
				</cfif>
			</cfloop>
		</cfloop>
		
		<!--- do the same for any sub folders --->
		<cfdirectory action="list" type="dir" directory="#arguments.folder#" name="dirList">
		<cfloop query="dirList">
			<cfset deleteCFEncoded(folder = "#arguments.folder#\#dirList.name#", 
				lstOpenSource = lstOpenSource, 
				qryManifest = qryManifest,
				startFolder = arguments.startFolder)>
		</cfloop>
		
	</cfif>
	
</cffunction>
Deleting files no longer needed:<br/><br/>
<cfset deleteCFEncoded(folder = application.paths.sDrive, lstOpenSource = lstOpenSource, qryManifest = qryManifest)>